-- ddr_demux works in pair with ddr_mux to move data between two FPGAs
-- using DDR I/O register at twice the clock rate to reduce interconnects.
-- link_a into ddr_mux comes out as q_a
-- link_b into ddr_mux comes out as q_b
-- the net delay inserted is one clock cycle
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use mylib.dfea_pack.all;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ddr_mux is
    Port ( clk : in std_logic;
           clkn : in std_logic;
           link_a : in std_logic_vector(27 downto 0);
           link_b : in std_logic_vector(27 downto 0);
           link_out : out std_logic_vector(27 downto 0));
end ddr_mux;

architecture my_arch of ddr_mux is
begin
g_ddr: for i in link_a'range generate
   fddr:  fddrrse
	      port map(
			    d0 => link_a(i),
				 d1 => link_b(i),
				 c0 => clk,
				 c1 => clkn,
				 ce => vcc,
				 r  => gnd,
				 s  => gnd,
				 q  => link_out(i));
end generate;
end my_arch;
