-- priority encode a block both directions, yielding two
-- answers.  

-- jamieson olsen <jamieson@fnal.gov>
-- 28 june 1999
-- revised 14 march 2000

-- note: this file has registered inputs.  the input registers
-- should be commented out when the input of this module is attached to another 
-- module with output registers.  (to avoid unnecessary registers connected
-- together!)
--  01 Jul 2004:    changed to synchronous reset S.X.Wu

library ieee;
use ieee.std_logic_1164.all;

entity prior22 is
	port (
		block_in: 	in std_logic_vector (21 downto 0);	-- the block of data
		clock:		in std_logic;
		reset:		in std_logic;
		l_index: 	out std_logic_vector (4 downto 0);
		r_index: 	out std_logic_vector (4 downto 0)
	);
end prior22;


architecture prior22_arch of prior22 is

	-- define registers
	signal lmost:			std_logic_vector(4 downto 0);		-- the leftmost set bit in the block
	signal rmost:			std_logic_vector(4 downto 0);		-- the rightmost set bit in the block
 begin


	-- combinatorial stuff
	l_index(4 downto 0) 	<= lmost(4 downto 0);
	r_index(4 downto 0) 	<= rmost(4 downto 0);




	-- sequential stuff
--  01 Jul 2004:    changed to synchronous reset


--	process(clock, reset)
--	 begin

--		if (reset='0') then

--			lmost <= "00000";
--			rmost <= "00000";

--		elsif rising_edge(clock) then
process(clock)
begin
  if(clock'event and clock = '1')then
    if(reset = '0')then
			lmost <= "00000";
			rmost <= "00000";
	 else
			if (block_in(21)='1') then
				lmost <= "10110";	-- 22

			elsif (block_in(20) = '1') then
				lmost <= "10101";	-- 21

			elsif (block_in(19) = '1') then
				lmost <= "10100";	-- 20

			elsif (block_in(18) = '1') then
				lmost <= "10011";	-- 19

			elsif (block_in(17) = '1') then
				lmost <= "10010";	-- 18

			elsif (block_in(16) = '1') then
				lmost <= "10001";	-- 17

			elsif (block_in(15) = '1') then
				lmost <= "10000";	-- 16

			elsif (block_in(14) = '1') then
				lmost <= "01111";	-- 15

			elsif (block_in(13) = '1') then
				lmost <= "01110";	-- 14

			elsif (block_in(12) = '1') then
				lmost <= "01101";	-- 13

			elsif (block_in(11) = '1') then
				lmost <= "01100";	-- 12

			elsif (block_in(10) = '1') then
				lmost <= "01011";	-- 11

			elsif (block_in(9) = '1') then
				lmost <= "01010";	-- 10

			elsif (block_in(8) = '1') then
				lmost <= "01001";	-- 9

			elsif (block_in(7) = '1') then
				lmost <= "01000";	-- 8

			elsif (block_in(6) = '1') then
				lmost <= "00111";	-- 7

			elsif (block_in(5) = '1') then
				lmost <= "00110";	-- 6

			elsif (block_in(4) = '1') then
				lmost <= "00101";	-- 5

			elsif (block_in(3) = '1') then
				lmost <= "00100";	-- 4

			elsif (block_in(2) = '1') then
				lmost <= "00011";	-- 3

			elsif (block_in(1) = '1') then
				lmost <= "00010";	-- 2

			elsif (block_in(0) = '1') then
				lmost <= "00001";	-- 1

			else
				lmost <= "00000";	-- 0
			end if;


			if (block_in(0)='1') then
				rmost <= "00001";

			elsif( block_in(1)='1') then
				rmost <= "00010";

			elsif( block_in(2)='1') then
				rmost <= "00011";

			elsif( block_in(3)='1') then
				rmost <= "00100";

			elsif( block_in(4)='1') then
				rmost <= "00101";

			elsif( block_in(5)='1') then
				rmost <= "00110";

			elsif( block_in(6)='1') then
				rmost <= "00111";

			elsif( block_in(7)='1') then
				rmost <= "01000";

			elsif( block_in(8)='1') then
				rmost <= "01001";

			elsif( block_in(9)='1') then
				rmost <= "01010";

			elsif( block_in(10)='1') then
				rmost <= "01011";

			elsif( block_in(11)='1') then
				rmost <= "01100";

			elsif( block_in(12)='1') then
				rmost <= "01101";

			elsif( block_in(13)='1') then
				rmost <= "01110";

			elsif( block_in(14)='1') then
				rmost <= "01111";

			elsif( block_in(15)='1') then
				rmost <= "10000";

			elsif( block_in(16)='1') then
				rmost <= "10001";

			elsif( block_in(17)='1') then
				rmost <= "10010";

			elsif( block_in(18)='1') then
				rmost <= "10011";

			elsif( block_in(19)='1') then
				rmost <= "10100";

			elsif( block_in(20)='1') then
				rmost <= "10101";

			elsif( block_in(21)='1') then
				rmost <= "10110";

			else
				rmost <= "00000";
			end if;
		end if;
	end if;
end process;
end prior22_arch;
